Форум программистов, компьютерный форум, киберфорум
Наши страницы

С++ для начинающих

Войти
Регистрация
Восстановить пароль
 
Тамика
Котовчанин
917 / 460 / 145
Регистрация: 16.02.2010
Сообщений: 3,194
Записей в блоге: 27
#1

Снова try catch - C++

21.03.2014, 12:05. Просмотров 422. Ответов 11
Метки нет (Все метки)

Доброе утро всем!
Недавно спрашивала как работать с блоками try ... catch. В общем, прозрение так и не пришло, но доделать код хочется. Вот сделала пока такую штуку
C++
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
int_array::int_array(int n)
{
    try{
    if (n < 0)
        throw "Cannot initialize array with negative count of elements!";
 
    mas = new int[n];
    for (int i = 0; i < n; ++i)
        mas[i] = 0;
    size = n;
    capacity = n;
    }
    catch(const char* msg)
    {
        std::cout << msg;
    }
}
Теперь вопрос... Как сделать обработку исключения? То есть... Я не хочу в этом классе обрабатывать исключение, не хочу в этом классе делать вывод сообщения. Хочу сделать обработку в другом классе, Error например. Как это можно реализовать?
Заранее спасибо!
0
Надоела реклама? Зарегистрируйтесь и она исчезнет полностью.
Similar
Эксперт
41792 / 34177 / 6122
Регистрация: 12.04.2006
Сообщений: 57,940
21.03.2014, 12:05
Здравствуйте! Я подобрал для вас темы с ответами на вопрос Снова try catch (C++):

Как сделать чтобы таймер дойдя до 0 стартовал снова и снова? - C++
Здравствуйте :) Как сделать чтобы таймер дойдя до 0 стартовал снова и снова? TimerSec = 59; TimerMin = 6; for(int i = TimerSec;...

try-catch - C++
Читаю книгу Страуструпа. Он пишет (стр 232), что можно не передавать обработчику исключений какое либо значение. #include...

TRY/CATCH - C++
Здравствуйте! У меня есть: MASS; для простоты пояснения, x=rand();y=rand(),znacheniye=rand(); Как игнорировать ошибки...

try-catch - C++
Доброго времени суток, начал изучать исключения, и вот есть такой код: // new.cpp : Defines the entry point for the console...

Try catch - C++
try { throw pDoc-&gt;C; } catch (City) { return; } есть динамический City* C, ему присвается значение другого такого...

try-catch - C++
Какой тип проекта создавать в Visual Studio чтобы можно было сделать обработку исключений с try-catch? Или что сделать в Code Blocks с той...

11
0x10
2479 / 1652 / 248
Регистрация: 24.11.2012
Сообщений: 4,095
21.03.2014, 12:06 #2
Ну вообще это странно, что в данном случае хочется выводить сообщения прямо тут... А по теме, в блок catch добавьте после вывода сообщения:
C++
1
throw;
1
Тамика
Котовчанин
917 / 460 / 145
Регистрация: 16.02.2010
Сообщений: 3,194
Записей в блоге: 27
21.03.2014, 12:08  [ТС] #3
А зачем?
0
0x10
2479 / 1652 / 248
Регистрация: 24.11.2012
Сообщений: 4,095
21.03.2014, 12:13 #4
Чтобы бросить текущее обрабатываемое исключение дальше
http://ideone.com/fdXvc9
C++
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
25
26
27
28
29
30
31
32
33
34
35
#include <iostream>
#include <stdexcept>
 
class IntArray
{
public:
    IntArray(int size)
    {
        try
        {
            if (size < 0)
            {
                throw std::invalid_argument("Bad size");
            }
        }
        catch (const std::invalid_argument& ex)
        {
            std::cout << "IntArray::IntArray: " << ex.what() << std::endl;
            throw;
        }
    }
};
 
int main()
{
    try
    {
        IntArray a(-1);
    }
    catch (const std::invalid_argument& ex)
    {
        std::cout << "main: " << ex.what() << std::endl;
    }
    return 0;
}
1
Тамика
Котовчанин
917 / 460 / 145
Регистрация: 16.02.2010
Сообщений: 3,194
Записей в блоге: 27
21.03.2014, 12:15  [ТС] #5
ex.what()
А что эта функция делает?
0
DrOffset
7376 / 4453 / 1009
Регистрация: 30.01.2014
Сообщений: 7,304
21.03.2014, 12:15 #6
Цитата Сообщение от Тамика Посмотреть сообщение
Я не хочу в этом классе обрабатывать исключение, не хочу в этом классе делать вывод сообщения.
Ловить, чтобы вывести сообщение, потом опять бросать может быть не совсем эффективно. Этим пользоваться нужно в других, более сложных случаях. А в тут можно просто:
C++
1
2
3
4
5
6
7
8
9
10
11
12
13
14
int_array::int_array(int n)
{
    if (n < 0)
    {
        char const * msg = "Cannot initialize array with negative count of elements!";
        std::cout << msg; 
        throw msg;
    } 
    mas = new int[n];
    for (int i = 0; i < n; ++i)
        mas[i] = 0;
    size = n;
    capacity = n;
}
А обрабатывать уже в другом месте. Если хочется постоянно иметь лог места, где выброшено исключение - можно сделать вот так:
C++
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
24
inline 
void throw_mylib_exception(char const * mes, char const * func, char const * file, int line)
{
    std::cout << "exception thrown from function " << func << " at file " << file << ", line " << line << std::endl;
    throw mes;
}
 
#define THROW_MYLIB_EXCEPTION(mes) \
     throw_mylib_exception(mes, __FUNCTION__, __FILE__, __LINE__)
 
......
 
int_array::int_array(int n)
{
    if (n < 0)
    {
        THROW_MYLIB_EXCEPTION("Cannot initialize array with negative count of elements!");
    } 
    mas = new int[n];
    for (int i = 0; i < n; ++i)
        mas[i] = 0;
    size = n;
    capacity = n;
}
1
0x10
2479 / 1652 / 248
Регистрация: 24.11.2012
Сообщений: 4,095
21.03.2014, 12:17 #7
Цитата Сообщение от Тамика Посмотреть сообщение
А что эта функция делает?
Смотрим в доки
раз http://www.cplusplus.com/reference/exception/exception/
два http://www.cplusplus.com/reference/exception/exception/what/
три http://www.cplusplus.com/reference/stdexcept/invalid_argument/

Словами: в конструктор исключения я передал строку с описанием ошибки, она доступна через метод what().
1
DrOffset
7376 / 4453 / 1009
Регистрация: 30.01.2014
Сообщений: 7,304
21.03.2014, 12:22 #8
Ну и присоединяюсь к 0x10, кидать указатель на строку в качестве исключения не совсем кошерно. Использовать соответствующие классы или написать свои, заимев при этом требуемую типобезопасность, гораздо лучше.
0
Тамика
Котовчанин
917 / 460 / 145
Регистрация: 16.02.2010
Сообщений: 3,194
Записей в блоге: 27
21.03.2014, 12:34  [ТС] #9
Огромное спасибо! Кое-что прояснили...
Сделала так:
C++
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
void int_array::erase(int index)
{
    try
    {
        if (index < 0) 
            throw std::invalid_argument("Bad index to erase!");
        if (index > size) 
            throw std::invalid_argument("Index out of range!");
        int *temp = new int[size-1];
        for (int i = 0; i < index; ++ i)
            temp[i] = mas[i];
        for (int i = index + 1; i < size; ++i)
            temp[i - 1] = mas[i];
        size = size - 1;
        int *t = mas;
        mas = temp;
        delete [] t;
    }
    catch(const std::invalid_argument& ex)
    {
        throw;
    }
}
А в мейне делаю обработку
C++
1
2
3
4
5
6
7
8
9
10
11
int main(){
...
    catch(const std::invalid_argument& ex)
    {
        switch(ex.what())
        {
            
        }
    }
 
}
Почему так нельзя?..(
Хочу, в зависимости от приходящего сообщения, разные обработки делать... А компилятор ругается. Я опять что-то недопоняла.
0
DrOffset
7376 / 4453 / 1009
Регистрация: 30.01.2014
Сообщений: 7,304
21.03.2014, 12:41 #10
При таком варианте try-catch в функции вообще не нужны:
Цитата Сообщение от Тамика Посмотреть сообщение
C++
1
2
3
4
5
6
7
8
9
10
11
12
13
14
15
16
17
18
19
20
21
22
23
void int_array::erase(int index)
{
    //try
    //{
        if (index < 0) 
            throw std::invalid_argument("Bad index to erase!");
        if (index > size) 
            throw std::invalid_argument("Index out of range!");
        int *temp = new int[size-1];
        for (int i = 0; i < index; ++ i)
            temp[i] = mas[i];
        for (int i = index + 1; i < size; ++i)
            temp[i - 1] = mas[i];
        size = size - 1;
        int *t = mas;
        mas = temp;
        delete [] t;
    //}
    //catch(const std::invalid_argument& ex)
    //{
    //    throw;
    //}
}
Цитата Сообщение от Тамика Посмотреть сообщение
Почему так нельзя?..(
В switch можно только интегральные типы сравнивать с интегральными константами.

Правильный способ либо завести по типу исключения на каждый тип ошибки,
C++
1
2
3
4
5
6
7
8
9
10
11
12
try
{
 ....
}
catch(bad_index const &)
{
...
}
catch(out_of_range const &)
{
...
}
либо (что чуть хуже) передавать помимо строки еще и тип ошибки в виде константы (например из enum). Тестить саму строку с исключением как-то не очень.
1
0x10
2479 / 1652 / 248
Регистрация: 24.11.2012
Сообщений: 4,095
21.03.2014, 12:43 #11
Цитата Сообщение от DrOffset Посмотреть сообщение
Тестить саму строку с исключением как-то не очень
Да еще и в switch.

Тамика, по-моему, это тот момент, когда надо просто открыть книгу или документацию, примеры есть.
0
Тамика
Котовчанин
917 / 460 / 145
Регистрация: 16.02.2010
Сообщений: 3,194
Записей в блоге: 27
21.03.2014, 12:56  [ТС] #12
по-моему, это тот момент, когда надо просто открыть книгу или документацию, примеры есть.
Этот момент уже был. Потому и написала на форум. Всегда, перед тем, как обратиться сюда, я пытаюсь разобраться сама. Если не выходит - пишу.
0
21.03.2014, 12:56
MoreAnswers
Эксперт
37091 / 29110 / 5898
Регистрация: 17.06.2006
Сообщений: 43,301
21.03.2014, 12:56
Привет! Вот еще темы с ответами:

Try и catch - C++
Пытался сделать простую структуру,чтобы в блоке try задавалось значение переменной x, и если это значение равно,например, 5,то блок catch...

try . catch - C++
можно ли провести данную операцию для функции erase у вектора??? пытался, что-то не получилось: #include &lt;vector&gt; #include &lt;algorithm&gt; ...

try catch - C++
Здравствуйте. В c++ новичёк, с try catch никогда толком не работал, а тут пришлось. Нужно сделать защиту от ввода всего кроме цифр. вот...

Try-catch - C++
Добрый вечер, #include &lt;iostream&gt; using namespace std; void F1(int); void F2(int, int); void F3(int, int, int);


Искать еще темы с ответами

Или воспользуйтесь поиском по форуму:
12
Ответ Создать тему
Опции темы

КиберФорум - форум программистов, компьютерный форум, программирование
Powered by vBulletin® Version 3.8.9
Copyright ©2000 - 2017, vBulletin Solutions, Inc.
Рейтинг@Mail.ru